using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OracleClient;
using System.Data;

namespace OracleWinForms
{
    /// <summary>
    /// ,       .
    /// </summary>
    class AccountService
    {
        private OracleConnection connection;

        /// <summary>
        ///    Oracle.
        /// </summary>
        public OracleConnection Connection
        {
            get { return connection; }
            set { connection = value; }
        }

        /// <summary>
        ///       .
        /// </summary>
        /// <param name="from"> -</param>
        /// <param name="to"> -</param>
        /// <param name="amount"> </param>
        public void transfer(int from, int to, double amount)
        {
            OracleCommand cmd = null;
            if (Connection.State == ConnectionState.Closed)
            {
                Connection.Open();
            }

            //    
            cmd = Connection.CreateCommand();
            cmd.CommandText = "update ACCOUNT set AMOUNT=AMOUNT+:amount where id=:id";
            cmd.Parameters.Add("amount", OracleType.VarChar);
            cmd.Parameters.Add("id", OracleType.Int32);
            cmd.Prepare();

            try
            {
                OracleTransaction tx = Connection.BeginTransaction();
                cmd.Transaction = tx;

                //    -
                cmd.Parameters[0].Value = -amount;
                cmd.Parameters[1].Value = from;
                cmd.ExecuteNonQuery();

                //    -
                cmd.Parameters["amount"].Value = amount;
                cmd.Parameters["id"].Value = to;
                cmd.ExecuteNonQuery();

                // - -     .
                OracleCommand queryCmd = Connection.CreateCommand();
                queryCmd.Transaction = tx;
                queryCmd.CommandText = "select id from ACCOUNT where Amount<0 and id=" + from;
                if (queryCmd.ExecuteReader().HasRows)
                {
                    //  ,     -     
                    throw new Exception("Account has no enough amount to transfer");
                }

                //    .
                cmd.Transaction.Commit();
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.Message + "\r\n" + e.StackTrace);
                if (cmd != null)
                {
                    //  
                    cmd.Transaction.Rollback();
                }
            }
        }
    }
}
